proc openConnection {channel ip port} {
  global Server
  fileevent $channel readable [list processLine $channel]
  fconfigure $channel -buffering line
  
  # initialize the test counter
  set Server($channel.testNum) 0
}

proc processLine {channel} {
    global Server

    set len [gets $channel line]

    if {[eof $channel]} {
        close $channel
        unset Server($channel.testNum)
	return
    }
    if {[string first RESULT $line] == 0} {
      puts "$Server(descript): $line"
    }
    runTest $channel
}

proc runTest {channel} {
    global Server

    if {$Server($channel.testNum) >= [llength $Server(tests)]} {
      puts $channel {set Client(done) 1}
    } else {
      foreach {Server(descript) params} \
        [lindex $Server(tests) $Server($channel.testNum)] {}
      puts $channel "array set Client [list $params]"
      puts $channel "runTest"
      incr Server($channel.testNum)
    }
}

set Server(tests) {
  {{bad address } {IP 192.168.90.223 User badIP Passwd badPasswd}}
  {{bad username} {IP 192.168.90.222 User badUser Passwd badPasswd}}
  {{good username} {IP 192.168.90.222 User goodUser Passwd goodPasswd}}
  {{anonymous/badPasswd} {IP 192.168.90.222 User anonymous Passwd badPasswd}}
  {{anonymous/goodpwd} {IP 192.168.90.222 User anonymous Passwd foo@bar.com}}
}


socket -server openConnection 23456

set Server(done) 0

vwait Server(done)
